From ab73957a4e7416f744da1355af274d81a8989602 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 23 2020 01:25:43 +0000
Subject: [PATCH 336/2232] Add ui test for unnamed receiver type error message


---

diff --git a/tests/ui/unnamed_receiver.rs b/tests/ui/unnamed_receiver.rs
new file mode 100644
index 0000000..917e991
--- /dev/null
+++ b/tests/ui/unnamed_receiver.rs
@@ -0,0 +1,14 @@
+#[cxx::bridge]
+mod ffi {
+    extern "C" {
+        type One;
+        type Two;
+        fn f(&mut self);
+    }
+
+    extern "Rust" {
+        fn f(self: &Self);
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/unnamed_receiver.stderr b/tests/ui/unnamed_receiver.stderr
new file mode 100644
index 0000000..e66d9e3
--- /dev/null
+++ b/tests/ui/unnamed_receiver.stderr
@@ -0,0 +1,11 @@
+error: unnamed receiver type is only allowed if the surrounding extern block contains exactly one extern type; use `self: &mut TheType`
+ --> $DIR/unnamed_receiver.rs:6:14
+  |
+6 |         fn f(&mut self);
+  |              ^^^^^^^^^
+
+error: unnamed receiver type is only allowed if the surrounding extern block contains exactly one extern type; use `self: &TheType`
+  --> $DIR/unnamed_receiver.rs:10:20
+   |
+10 |         fn f(self: &Self);
+   |                    ^^^^^

